// Проект погодной станции/часов V1.0
// Copyright (C) 2014 Шихарбеев А.В

#include <RF24Network.h>
#include <RF24.h>
#include <SPI.h>
#include <Time.h>
#include <DHT.h>

#include <Adafruit_NeoPixel.h>

#define PIN 2
#define PIXEL_COUNT 177
Adafruit_NeoPixel strip = Adafruit_NeoPixel(PIXEL_COUNT, PIN, NEO_GRB + NEO_KHZ800);

DHT dht(3, DHT22, 6);


//#define DEBUG 1
const uint16_t nrf24_node       = 0x03;

#include "ClassCoder.h"
//#include "ClassAVG.h"

//Глобальные переменные

float t = 0;
float p = 0;
float h = 0;
unsigned long ms_rx = 0;

int display_mode = 0;

unsigned long ms1 = 0;
unsigned long ms2 = 0;
unsigned long ms3 = 0;

float T2=0,H2=0;
boolean time_sign = true;
long int t_correct = 0;

long int cur_ms;
unsigned long n = 0;



RF24 radio(9,10);
RF24Network network(radio);


uint16_t DIGIT[] = {
  0x1FBF, /* 0 */
  0x1F00, /* 1 */
  0x1DF7, /* 2 */
  0x1FF5, /* 3 */
  0x1F5C, /* 4 */ 
  0x17FD, /* 5 */ 
  0x17FF, /* 6 */ 
  0x1F30, /* 7 */ 
  0x1FFF, /* 8 */ 
  0x1FFD  /* 9 */ 
  
};

// Позиция каждой цифры в последовательности WS2813
uint8_t POSITION[] = { 120,134,150,164 };
// Позиция каждого "луча" в WS2813
uint8_t POSITION1[] = { 60,50,40,30,20,10,0,110,100,90,80,70 };

unsigned int R_MASK[] = { 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100, 0x0200, 0x0400, 0x0800, 0x1000 };  
  
/**
* Вывод одной цифры на табло
*/  
void PutChar(char c,uint8_t digit,uint32_t color){
    uint16_t mask = 0;
    uint32_t color1        = strip.Color(0, 0, 0);
    switch(c){
      case '0': mask = DIGIT[0]; break;
      case '1': mask = DIGIT[1]; break;
      case '2': mask = DIGIT[2]; break;
      case '3': mask = DIGIT[3]; break;
      case '4': mask = DIGIT[4]; break;
      case '5': mask = DIGIT[5]; break;
      case '6': mask = DIGIT[6]; break;
      case '7': mask = DIGIT[7]; break;
      case '8': mask = DIGIT[8]; break;
      case '9': mask = DIGIT[9]; break;
      default : mask = 0;
    }
//    mask = 0xFFFF;
    for( int i=0; i<13; i++ )
       if( mask & R_MASK[i] )strip.setPixelColor(POSITION[digit]+i, color);
       else strip.setPixelColor(POSITION[digit]+i, color1);


}  

/**
* Очистка всех WS2813
*/
void Clear(){
   for( int i=0; i<PIXEL_COUNT; i++ )strip.setPixelColor(i, 0);
}  


uint8_t pos1 =0 ;

/**
* Вывод времени или температуры в зависимости от режима отображения
*/
void PrintTime(time_t tm1, boolean sign)
{
    uint8_t h = hour(tm1);
    uint8_t m = minute(tm1);
    uint8_t s = second(tm1);
    uint8_t h1;
    uint8_t m1 = m/5;
    uint8_t m2 = m%5;
    uint16_t pos = POSITION1[s/5];
    if( h < 12 )h1 = h;
    else h1 = h - 12;
  //if( h != hr || m != mn ){
     Clear();
     char c;
     uint32_t color=0;
     uint16_t xx;
     boolean minus = false;
     switch( display_mode ){
       case 1://Наружная температура
          color = strip.Color(0,100,100);
       
          if( t >= 0 )xx = t*10;
          else {
            xx = t*-10;
            minus = true;
          }
          if( minus ){
             strip.setPixelColor(POSITION[0]+2,color);
             strip.setPixelColor(POSITION[0]+6,color);
             strip.setPixelColor(POSITION[0]+10,color);
          }
          c = '0' + (xx/100)%10;
          if( c != '0' )PutChar(c,1,color);
          c = '0' + (xx/10)%10;
          PutChar(c,2,color);
          c = '0' + xx%10;
          PutChar(c,3,color);
          strip.setPixelColor(163, color);
          break;   
       case 3://Внутренняя температура
          color = strip.Color(100,0,100);
       
          if( T2 >= 0 )xx = T2*10;
          else {
            xx = T2*-10;
            minus = true;
          }
          if( minus ){
             strip.setPixelColor(POSITION[0]+2,color);
             strip.setPixelColor(POSITION[0]+6,color);
             strip.setPixelColor(POSITION[0]+10,color);
          }
          c = '0' + (xx/100)%10;
          if( c != '0' )PutChar(c,1,color);
          c = '0' + (xx/10)%10;
          PutChar(c,2,color);
          c = '0' + xx%10;
          PutChar(c,3,color);
          strip.setPixelColor(163, color);
          break;   
      default: //Показ времени
          color = strip.Color(50,50,50);
          c = '0' + h%10;
          PutChar(c,1,color);
          c = '0' + (h/10)%10;
          PutChar(c,0,color);
          c = '0' + m%10;
          PutChar(c,3,color);
          c = '0' + (m/10)%10;
          PutChar(c,2,color);
          break;   
     }
     for( int j=0; j<12; j++){
        strip.setPixelColor(POSITION1[j],strip.Color(1,1,0));
        for( int i=6; i<=9; i++)strip.setPixelColor(POSITION1[j]+i,strip.Color(1,0,1));
        for( int i=1; i<=5; i++)strip.setPixelColor(POSITION1[j]+i,strip.Color(0,1,1));
     }

     for( int i=6; i<=9; i++)strip.setPixelColor(POSITION1[h1]+i,strip.Color(100,0,0));
     for( int i=1; i<=5; i++)strip.setPixelColor(POSITION1[m1]+i,strip.Color(0,0,100));
     
     if( sign ){
       if( display_mode == 0 || display_mode == 2 ){        
          strip.setPixelColor(147, color);
          strip.setPixelColor(148, color);
       }
       strip.setPixelColor(pos, strip.Color(0,255,0));
       strip.setPixelColor(POSITION1[m1]+5-m2,strip.Color(0,0,255));
       pos1 = pos;
     }
     else{
       if( display_mode == 0 || display_mode == 2 ){        
          strip.setPixelColor(147, 0);
          strip.setPixelColor(148, 0);
       }
       strip.setPixelColor(POSITION1[m1]+5-m2,0);
       strip.setPixelColor(pos1, 0);
     }
     
     strip.show();
#ifdef DEBUG
          Serial.print("TM=");
          Serial.print(h);
          if( sign )Serial.print(":");
          else Serial.print(" ");
          Serial.print(m);
          Serial.print(" ");
          Serial.print(s);
          Serial.print(" ");
          Serial.print(pos);
          Serial.println("");
#endif

     
}


void setup() {
#ifdef DEBUG
  Serial.begin(9600);
  Serial.println("OK");
#endif

   SPI.begin();
   radio.begin();
   network.begin(nrf24_channel, nrf24_node);

  strip.begin();
  Clear();
  PutChar('0',0,strip.Color(255, 0, 0));
  PutChar('0',1,strip.Color(255, 0, 0));
  PutChar('0',2,strip.Color(255, 0, 0));
  PutChar('0',3,strip.Color(255, 0, 0));
  strip.show(); // Initialize all pixels to 'off'
  
  dht.begin();

 
  
} 

     
void loop() {
  cur_ms = millis();
 

  unsigned long t_cur = (cur_ms/1000)%86400;

  network.update();

  // Is there anything ready for us?
  while ( network.available() )
  {
    RF24NetworkHeader header;
    struct TSInfoPacket1 sensor;
    network.read(header,&sensor,sizeof(sensor));
    if( header.type == TYPE_METEO1 ){
       t = round(sensor.T*10)/10.0;
       p = round(sensor.P*10)/10.0;
       h = sensor.H;
       ms_rx = cur_ms;
#ifdef DEBUG
          Serial.print("SENS: Temp=");
          Serial.print(t);
          Serial.print(" Press=");
          Serial.print(p);
          Serial.print(" Hum=");
          Serial.print(h);
          Serial.println("");
#endif
    }
    else if( header.type == TYPE_TIME1 ){
       t_correct = (unsigned long)sensor.Time - t_cur;
#ifdef DEBUG
          Serial.print("Time=");
          Serial.print(hour(sensor.Time));
          Serial.print(":");
          Serial.print(minute(sensor.Time));
          Serial.println("");
#endif
    }
//    ms2 = cur_ms;
  }


  if( cur_ms - ms1 < 0 || cur_ms - ms1 > 500 ){
//     if( is_time_mode ){ 
//     }
     time_t tm1 = t_cur + t_correct;
     PrintTime(tm1,time_sign);
     time_sign = !time_sign;
     ms1 = cur_ms;
  }

// Считываем температуру и влажность в комнате  
  if( cur_ms - ms3 < 0 || cur_ms - ms3 > 3000 ){
     switch( display_mode ){
       case 0:  display_mode=1;break;
       case 1:  display_mode=2;break;
       case 2:  display_mode=3;break;
       default: display_mode=0;
     }
     ms3 = cur_ms;
  }     


// Считываем температуру и влажность в комнате  
  if( cur_ms - ms2 < 0 || cur_ms - ms2 > 30000 ){
// Опрашивает датчик температуры
     T2 = dht.readTemperature();
     H2 = dht.readHumidity();
 #ifdef DEBUG
     Serial.print("Temp2 = ");
     Serial.print(T2,1);
     Serial.print(",Hum2=");
     Serial.print(H2,1);
     Serial.println("");
#endif 
     ms2 = cur_ms;
  }     


} 






